//+------------------------------------------------------------------+
//|                                                        ZZ_v3.mq4 |
//|                                                 George Tischenko |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "George Tischenko"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Yellow

extern int ExtPeriod=5;   //    

double MP;
double UP[],DN[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
  IndicatorDigits(Digits);
  IndicatorBuffers(2);
  
  SetIndexBuffer(0,UP);
  SetIndexStyle(0,DRAW_ZIGZAG,STYLE_SOLID,2);
  SetIndexBuffer(1,DN);
  SetIndexStyle(1,DRAW_ZIGZAG);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
  return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  int i;
  int counted_bars=IndicatorCounted();
  if(counted_bars>0) i=Bars-counted_bars;
  else i=Bars-ExtPeriod-1;
  
//========  
  while(i>=0)
    { 
    int j=i,k=i,m,n,min,curPeak=0,lastPeak=0,Comb=0;
//----    
    while(UP[j]==EMPTY_VALUE) {if(j>Bars-ExtPeriod) break; j++;} //   
    while(DN[k]==EMPTY_VALUE) {if(k>Bars-ExtPeriod) break; k++;} //   
    
    min=MathMin(j,k);
    if(min<Bars-ExtPeriod) // curPeak==0    
      {
      if(j<k) curPeak=1;
      else
        {
        if(j>k) curPeak=-1;
        else if(Comb<2) curPeak=2; //j==k,      
        }
      }
//----         ,     :
    if(curPeak!=0)
      {
      if(min==i || curPeak==2)
        {
        m=min; n=m;
        while(m==n)
          {
          m++; n++;
          while(UP[m]==EMPTY_VALUE) {if(m>Bars-ExtPeriod) break; m++;} 
          while(DN[n]==EMPTY_VALUE) {if(n>Bars-ExtPeriod) break; n++;} 
          if(MathMax(m,n)>Bars-ExtPeriod) break;
          }
        min=MathMin(m,n);
        if(min<Bars-ExtPeriod && min>i) // lastPeak==0     
          {
          if(m<n) lastPeak=1;
          else lastPeak=-1; //   j==k     while(j==k),     
          }//..         Highest  Lowest,       ,  lastPeak=0;
        }
      }
//----          
    double H=High[iHighest(NULL,0,MODE_HIGH,ExtPeriod,i)];
    double L=Low[iLowest(NULL,0,MODE_LOW,ExtPeriod,i)];
    
    if(High[i]==H && Low[i]>L) Comb=1;
    if(High[i]<H && Low[i]==L) Comb=-1;
    if(High[i]==H && Low[i]==L) Comb=2;     
//----   :
    switch(Comb)
      {
      case 1 : //(High[i]==H && Low[i]>L) Comb=1;
        {
        switch(curPeak)
          {
          case 1 : //  (,   )
            {
            switch(lastPeak)
              {
              case 0 : //,      
                {//  :
                if(UP[j]<H) {UP[j]=EMPTY_VALUE; UP[i]=H;}
                break;
                }
              case -1 : UP[i]=H; break; //    ,   (  ) -    
              case 1 : //           
                {//       j,     ()
                j=i+1;
                while(UP[j]==EMPTY_VALUE) {if(j>Bars-ExtPeriod) break; j++;}
                if(UP[j]<H) {UP[j]=EMPTY_VALUE; UP[i]=H;}  
                }
              }
            break;
            }
          case 2 : //      [j]      
            {
            switch(lastPeak)
              {
              case 1 : //  - 
                {//   :
                if(UP[j]<H) {UP[j]=EMPTY_VALUE; UP[i]=H;}
                break;
                }
              default : UP[i]=H; //    (0)     -  (-1):      
              }
            break;
            }
          default : UP[i]=H; //  (0)    (,   ) (-1) -      ,   
          }
        break;
        }
        
      case -1 : //(High[i]<H && Low[i]==L) Comb=-1;
        {
        switch(curPeak)
          {
          case -1 : //  (,   )
            {
            switch(lastPeak)
              {
              case 0 : //     
                {//    
                if(DN[k]>L) {DN[k]=EMPTY_VALUE; DN[i]=L;}
                break;
                }
              case 1 : DN[i]=L; break; //    ,      - 
              case -1 : //          
                {//       k,     ()
                k=i+1;
                while(DN[k]==EMPTY_VALUE) {if(k>Bars-ExtPeriod) break; k++;}
                if(DN[k]>L) {DN[k]=EMPTY_VALUE; DN[i]=L;}  
                }
              }
            break;
            }
          case 2 : //      [k]      
            {
            switch(lastPeak)
              {
              case -1 : //  - 
                {
                if(DN[k]>L) {DN[k]=EMPTY_VALUE; DN[i]=L;}
                break;
                }
              default : DN[i]=L; //    (0)     -  (1),    
              }
            break;
            }
          default : DN[i]=L; break; //  (0)    (,   ) (1) -      ,   
          }
        break;
        } 
        
      case 2 : UP[i]=H; DN[i]=L; //(High[i]==H && Low[i]==L) Comb=2;
      }
//----      
    i--;
    } 
//========
  return(0);
  }
//+------------------------------------------------------------------+